<%--
/*-------------------------------------------------------------------
//* The sample contained herein is provided to you "AS IS".
//* It is furnished by IBM as a simple example and has not been
//* thoroughly tested under all conditions.  IBM, therefore, cannot guarantee its
//* reliability, serviceability or functionality.
//*---------------------------------------------------------------------
--%>

<%@ page import="com.ibm.ws.cache.ServerCache" %>
<%@ page import="com.ibm.ws.cache.Cache" %>
<%@ page import="java.util.Set" %>
<%@ page contentType="text/html;charset=UTF-8"%>

<html>
<body>

  <h1>Invalidation By Dependency ID</h1>

  <%

  String errorMsg = null;

  String instance     = null;
  String dependencyId = null;

  boolean cacheClear  = false;

  try {

    instance     = request.getParameter("instance");
    dependencyId = request.getParameter("dependencyId");

    if ( instance == null || instance.length() == 0  ) {
      errorMsg = "Parameter <em>instance<em> is missing";
    } else if ( dependencyId == null || dependencyId.length() == 0  ) {
      errorMsg = "<em>dependencyId<em> parameter is missing.";
    } else {

        cacheClear = ( "clear".equals(dependencyId) || "clearall".equals(dependencyId));

        Cache cache = (Cache)ServerCache.getCache(instance);
        if ( cache != null ) {

          if ( cacheClear ) {

            cache.clear();

          } else {

            //This method invalidates in all caches all entries dependent on the specified id.
            // Parameters:
            // id - The cache id or data id.
            // waitOnInvalidation - True indicates that this method should not return until the invalidations have taken effect on all caches. False indicates that the invalidations will be queued for later batch processing.
            cache.invalidateById(dependencyId, true);
          }
        } else {

          errorMsg = "Unable to get Cache object reference for instance " + instance;
        }
    }
  } catch (Exception e) {
    errorMsg = "Exception " + e.getMessage();
    e.printStackTrace();
  }

  if ( errorMsg != null ) {
    out.println("<h1 style=\"color: red\">Failed to issue invalidation: " + errorMsg + "</h1>");
  } else {
    if ( cacheClear ) {
      out.println("<h2><em>Cache Clear</em> issued on <em>" + instance + "</em></h2>");
    } else {
      out.println("<h2> Invalidation by dependency Id <em>" + dependencyId + "</em> issued on <em>" + instance + "</em></h2>");    
    }
  }
%>

<p>
<a href="depid_select.jsp">Issue another</a>
</p>

</body>
</html>

